Interface CreateTimeOffRequest.Builder
- All Superinterfaces:
AwsRequest.Builder,Buildable,ConnectSchedulingRequest.Builder,CopyableBuilder<CreateTimeOffRequest.Builder,,CreateTimeOffRequest> SdkBuilder<CreateTimeOffRequest.Builder,,CreateTimeOffRequest> SdkPojo,SdkRequest.Builder
- Enclosing class:
CreateTimeOffRequest
-
Method Summary
Modifier and TypeMethodDescriptionapprovalType(String approvalType) Controls who approves the request.approvalType(ApprovalType approvalType) Controls who approves the request.clientToken(String clientToken) A unique, case-sensitive identifier that you provide to ensure that the operation completes no more than one time.description(String description) A description recorded on the time off request.The end of the time off window, exclusive.instanceId(String instanceId) The identifier of the Connect Customer instance.overrideConfiguration(Consumer<AwsRequestOverrideConfiguration.Builder> builderConsumer) Add an optional request override configuration.overrideConfiguration(AwsRequestOverrideConfiguration overrideConfiguration) Add an optional request override configuration.ruleFailureAction(String ruleFailureAction) Controls what happens when a configured rule fails.ruleFailureAction(RuleFailureAction ruleFailureAction) Controls what happens when a configured rule fails.shiftActivityId(String shiftActivityId) The identifier of the shift activity that defines the type of time off being requested.The start of the time off window, inclusive.The identifier of the user who the time off request is for.Methods inherited from interface software.amazon.awssdk.awscore.AwsRequest.Builder
overrideConfigurationMethods inherited from interface software.amazon.awssdk.services.connectscheduling.model.ConnectSchedulingRequest.Builder
buildMethods inherited from interface software.amazon.awssdk.utils.builder.CopyableBuilder
copyMethods inherited from interface software.amazon.awssdk.utils.builder.SdkBuilder
applyMutation, buildMethods inherited from interface software.amazon.awssdk.core.SdkPojo
equalsBySdkFields, sdkFieldNameToField, sdkFields
-
Method Details
-
instanceId
The identifier of the Connect Customer instance. This can be the ID or the ARN of the instance. You can find the instance ID in the Amazon Resource Name (ARN) of the instance.
- Parameters:
instanceId- The identifier of the Connect Customer instance. This can be the ID or the ARN of the instance. You can find the instance ID in the Amazon Resource Name (ARN) of the instance.- Returns:
- Returns a reference to this object so that method calls can be chained together.
-
userId
The identifier of the user who the time off request is for. This can be the ID or the ARN of the user.
- Parameters:
userId- The identifier of the user who the time off request is for. This can be the ID or the ARN of the user.- Returns:
- Returns a reference to this object so that method calls can be chained together.
-
shiftActivityId
The identifier of the shift activity that defines the type of time off being requested. This can be the ID or the ARN of the shift activity. It must be a time off activity. Activities that aren't set as Requestable are accepted.
- Parameters:
shiftActivityId- The identifier of the shift activity that defines the type of time off being requested. This can be the ID or the ARN of the shift activity. It must be a time off activity. Activities that aren't set as Requestable are accepted.- Returns:
- Returns a reference to this object so that method calls can be chained together.
-
startAt
The start of the time off window, inclusive. It must be no earlier than one year before the current date. Connect Customer stores the value as sent, to the millisecond.
- Parameters:
startAt- The start of the time off window, inclusive. It must be no earlier than one year before the current date. Connect Customer stores the value as sent, to the millisecond.- Returns:
- Returns a reference to this object so that method calls can be chained together.
-
endAt
The end of the time off window, exclusive. It must be after
StartAtand no later than 24 months after the current date. Connect Customer stores the value as sent, to the millisecond.- Parameters:
endAt- The end of the time off window, exclusive. It must be afterStartAtand no later than 24 months after the current date. Connect Customer stores the value as sent, to the millisecond.- Returns:
- Returns a reference to this object so that method calls can be chained together.
-
description
A description recorded on the time off request. If you omit it, the request has no description.
- Parameters:
description- A description recorded on the time off request. If you omit it, the request has no description.- Returns:
- Returns a reference to this object so that method calls can be chained together.
-
approvalType
Controls who approves the request.
AWAIT_APPROVALwaits for anApproveTimeOfforRejectTimeOffcall.AUTOMATIChas Connect Customer decide the request. For details, seeCreateTimeOff.- Parameters:
approvalType- Controls who approves the request.AWAIT_APPROVALwaits for anApproveTimeOfforRejectTimeOffcall.AUTOMATIChas Connect Customer decide the request. For details, seeCreateTimeOff.- Returns:
- Returns a reference to this object so that method calls can be chained together.
- See Also:
-
approvalType
Controls who approves the request.
AWAIT_APPROVALwaits for anApproveTimeOfforRejectTimeOffcall.AUTOMATIChas Connect Customer decide the request. For details, seeCreateTimeOff.- Parameters:
approvalType- Controls who approves the request.AWAIT_APPROVALwaits for anApproveTimeOfforRejectTimeOffcall.AUTOMATIChas Connect Customer decide the request. For details, seeCreateTimeOff.- Returns:
- Returns a reference to this object so that method calls can be chained together.
- See Also:
-
ruleFailureAction
Controls what happens when a configured rule fails.
REJECT, the default, records anERRORand ends the requestREJECTED, unless the whole window is in the past.OVERRIDErecords aWARNINGand ends the requestAPPROVED, like the Override time off rules option in the Connect Customer admin website.OVERRIDErequiresAUTOMATIC. WithAWAIT_APPROVAL,OVERRIDEfails withValidationException. Set it onApproveTimeOffinstead.OVERRIDEnever waivesCONFLICTING_TIME_OFF_REQUEST.- Parameters:
ruleFailureAction- Controls what happens when a configured rule fails.REJECT, the default, records anERRORand ends the requestREJECTED, unless the whole window is in the past.OVERRIDErecords aWARNINGand ends the requestAPPROVED, like the Override time off rules option in the Connect Customer admin website.OVERRIDErequiresAUTOMATIC. WithAWAIT_APPROVAL,OVERRIDEfails withValidationException. Set it onApproveTimeOffinstead.OVERRIDEnever waivesCONFLICTING_TIME_OFF_REQUEST.- Returns:
- Returns a reference to this object so that method calls can be chained together.
- See Also:
-
ruleFailureAction
Controls what happens when a configured rule fails.
REJECT, the default, records anERRORand ends the requestREJECTED, unless the whole window is in the past.OVERRIDErecords aWARNINGand ends the requestAPPROVED, like the Override time off rules option in the Connect Customer admin website.OVERRIDErequiresAUTOMATIC. WithAWAIT_APPROVAL,OVERRIDEfails withValidationException. Set it onApproveTimeOffinstead.OVERRIDEnever waivesCONFLICTING_TIME_OFF_REQUEST.- Parameters:
ruleFailureAction- Controls what happens when a configured rule fails.REJECT, the default, records anERRORand ends the requestREJECTED, unless the whole window is in the past.OVERRIDErecords aWARNINGand ends the requestAPPROVED, like the Override time off rules option in the Connect Customer admin website.OVERRIDErequiresAUTOMATIC. WithAWAIT_APPROVAL,OVERRIDEfails withValidationException. Set it onApproveTimeOffinstead.OVERRIDEnever waivesCONFLICTING_TIME_OFF_REQUEST.- Returns:
- Returns a reference to this object so that method calls can be chained together.
- See Also:
-
clientToken
A unique, case-sensitive identifier that you provide to ensure that the operation completes no more than one time. If this token matches a previous request, Connect Customer returns the result of that request and doesn't create another time off request. If you don't provide a token, the AWS SDK populates this field. If you reuse a client token with a different request body, the request fails with
ValidationException. For more information about idempotency, see Making retries safe with idempotent APIs.- Parameters:
clientToken- A unique, case-sensitive identifier that you provide to ensure that the operation completes no more than one time. If this token matches a previous request, Connect Customer returns the result of that request and doesn't create another time off request. If you don't provide a token, the AWS SDK populates this field. If you reuse a client token with a different request body, the request fails withValidationException. For more information about idempotency, see Making retries safe with idempotent APIs.- Returns:
- Returns a reference to this object so that method calls can be chained together.
-
overrideConfiguration
CreateTimeOffRequest.Builder overrideConfiguration(AwsRequestOverrideConfiguration overrideConfiguration) Description copied from interface:AwsRequest.BuilderAdd an optional request override configuration.- Specified by:
overrideConfigurationin interfaceAwsRequest.Builder- Parameters:
overrideConfiguration- The override configuration.- Returns:
- This object for method chaining.
-
overrideConfiguration
CreateTimeOffRequest.Builder overrideConfiguration(Consumer<AwsRequestOverrideConfiguration.Builder> builderConsumer) Description copied from interface:AwsRequest.BuilderAdd an optional request override configuration.- Specified by:
overrideConfigurationin interfaceAwsRequest.Builder- Parameters:
builderConsumer- AConsumerto which an emptyAwsRequestOverrideConfiguration.Builderwill be given.- Returns:
- This object for method chaining.
-